<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
    <!-- Generated by javadoc -->
    <title>VBAMacroReader (POI API Documentation)</title>
    <link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
    <script type="text/javascript" src="../../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="VBAMacroReader (POI API Documentation)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10,"i7":10,"i8":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";

</script>
<noscript>
    <div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.top.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/VBAMacroReader.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../../../index-all.html">Index</a></li>
        <li><a href="../../../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li><a href="../../../../../org/apache/poi/poifs/macros/VBAMacroExtractor.html"
               title="class in org.apache.poi.poifs.macros"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
        <li><a href="../../../../../org/apache/poi/poifs/macros/VBAMacroReader.ModuleImpl.html"
               title="class in org.apache.poi.poifs.macros"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
    </ul>
    <ul class="navList">
        <li><a href="../../../../../index.html?org/apache/poi/poifs/macros/VBAMacroReader.html" target="_top">Frames</a>
        </li>
        <li><a href="VBAMacroReader.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_top">
        <li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li><a href="#nested.class.summary">Nested</a>&nbsp;|&nbsp;</li>
            <li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
            <li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
            <li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.top">
        <!--   -->
    </a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
    <div class="subTitle">org.apache.poi.poifs.macros</div>
    <h2 title="Class VBAMacroReader" class="title">Class VBAMacroReader</h2>
</div>
<div class="contentContainer">
    <ul class="inheritance">
        <li>java.lang.Object</li>
        <li>
            <ul class="inheritance">
                <li>org.apache.poi.poifs.macros.VBAMacroReader</li>
            </ul>
        </li>
    </ul>
    <div class="description">
        <ul class="blockList">
            <li class="blockList">
                <dl>
                    <dt>All Implemented Interfaces:</dt>
                    <dd>java.io.Closeable, java.lang.AutoCloseable</dd>
                </dl>
                <hr>
                <br>
                <pre>public class <span class="typeNameLabel">VBAMacroReader</span>
extends java.lang.Object
implements java.io.Closeable</pre>
                <div class="block"><p>Finds all VBA Macros in an office file (OLE2/POIFS and OOXML/OPC),
                    and returns them.
                </p>
                    <p>
                        <b>NOTE:</b> This does not read macros from .ppt files.
                        See org.apache.poi.hslf.usermodel.TestBugs.getMacrosFromHSLF() in the scratchpad
                        module for an example of how to do this. Patches that make macro
                        extraction from .ppt more elegant are welcomed!
                    </p></div>
                <dl>
                    <dt><span class="simpleTagLabel">Since:</span></dt>
                    <dd>3.15-beta2</dd>
                </dl>
            </li>
        </ul>
    </div>
    <div class="summary">
        <ul class="blockList">
            <li class="blockList">
                <!-- ======== NESTED CLASS SUMMARY ======== -->
                <ul class="blockList">
                    <li class="blockList"><a name="nested.class.summary">
                        <!--   -->
                    </a>
                        <h3>Nested Class Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Nested Class Summary table, listing nested classes, and an explanation">
                            <caption><span>Nested Classes</span><span class="tabEnd">&nbsp;</span></caption>
                            <tr>
                                <th class="colFirst" scope="col">Modifier and Type</th>
                                <th class="colLast" scope="col">Class and Description</th>
                            </tr>
                            <tr class="altColor">
                                <td class="colFirst"><code>protected static class&nbsp;</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/macros/VBAMacroReader.ModuleImpl.html"
                                        title="class in org.apache.poi.poifs.macros">VBAMacroReader.ModuleImpl</a></span></code>&nbsp;
                                </td>
                            </tr>
                            <tr class="rowColor">
                                <td class="colFirst"><code>protected static class&nbsp;</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/macros/VBAMacroReader.ModuleMap.html"
                                        title="class in org.apache.poi.poifs.macros">VBAMacroReader.ModuleMap</a></span></code>&nbsp;
                                </td>
                            </tr>
                        </table>
                    </li>
                </ul>
                <!-- =========== FIELD SUMMARY =========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="field.summary">
                        <!--   -->
                    </a>
                        <h3>Field Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Field Summary table, listing fields, and an explanation">
                            <caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
                            <tr>
                                <th class="colFirst" scope="col">Modifier and Type</th>
                                <th class="colLast" scope="col">Field and Description</th>
                            </tr>
                            <tr class="altColor">
                                <td class="colFirst"><code>protected static java.lang.String</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/macros/VBAMacroReader.html#VBA_PROJECT_OOXML">VBA_PROJECT_OOXML</a></span></code>&nbsp;
                                </td>
                            </tr>
                            <tr class="rowColor">
                                <td class="colFirst"><code>protected static java.lang.String</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/macros/VBAMacroReader.html#VBA_PROJECT_POIFS">VBA_PROJECT_POIFS</a></span></code>&nbsp;
                                </td>
                            </tr>
                        </table>
                    </li>
                </ul>
                <!-- ======== CONSTRUCTOR SUMMARY ======== -->
                <ul class="blockList">
                    <li class="blockList"><a name="constructor.summary">
                        <!--   -->
                    </a>
                        <h3>Constructor Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Constructor Summary table, listing constructors, and an explanation">
                            <caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
                            <tr>
                                <th class="colOne" scope="col">Constructor and Description</th>
                            </tr>
                            <tr class="altColor">
                                <td class="colOne"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/macros/VBAMacroReader.html#VBAMacroReader-java.io.File-">VBAMacroReader</a></span>(java.io.File&nbsp;file)</code>&nbsp;
                                </td>
                            </tr>
                            <tr class="rowColor">
                                <td class="colOne"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/macros/VBAMacroReader.html#VBAMacroReader-java.io.InputStream-">VBAMacroReader</a></span>(java.io.InputStream&nbsp;rstream)</code>&nbsp;
                                </td>
                            </tr>
                            <tr class="altColor">
                                <td class="colOne"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/macros/VBAMacroReader.html#VBAMacroReader-org.apache.poi.poifs.filesystem.POIFSFileSystem-">VBAMacroReader</a></span>(<a
                                        href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html"
                                        title="class in org.apache.poi.poifs.filesystem">POIFSFileSystem</a>&nbsp;fs)</code>&nbsp;
                                </td>
                            </tr>
                        </table>
                    </li>
                </ul>
                <!-- ========== METHOD SUMMARY =========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.summary">
                        <!--   -->
                    </a>
                        <h3>Method Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Method Summary table, listing methods, and an explanation">
                            <caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span
                                    id="t2" class="tableTab"><span><a
                                    href="javascript:show(2);">Instance Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a
                                    href="javascript:show(8);">Concrete Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span></caption>
                            <tr>
                                <th class="colFirst" scope="col">Modifier and Type</th>
                                <th class="colLast" scope="col">Method and Description</th>
                            </tr>
                            <tr id="i0" class="altColor">
                                <td class="colFirst"><code>void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/macros/VBAMacroReader.html#close--">close</a></span>()</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i1" class="rowColor">
                                <td class="colFirst"><code>protected void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/macros/VBAMacroReader.html#findMacros-org.apache.poi.poifs.filesystem.DirectoryNode-org.apache.poi.poifs.macros.VBAMacroReader.ModuleMap-">findMacros</a></span>(<a
                                        href="../../../../../org/apache/poi/poifs/filesystem/DirectoryNode.html"
                                        title="class in org.apache.poi.poifs.filesystem">DirectoryNode</a>&nbsp;dir,
                                    <a href="../../../../../org/apache/poi/poifs/macros/VBAMacroReader.ModuleMap.html"
                                       title="class in org.apache.poi.poifs.macros">VBAMacroReader.ModuleMap</a>&nbsp;modules)</code>
                                    <div class="block">Recursively traverses directory structure rooted at <tt>dir</tt>.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i2" class="altColor">
                                <td class="colFirst"><code>protected void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/macros/VBAMacroReader.html#findModuleNameMap-org.apache.poi.poifs.filesystem.DirectoryNode-java.util.Map-org.apache.poi.poifs.macros.VBAMacroReader.ModuleMap-">findModuleNameMap</a></span>(<a
                                        href="../../../../../org/apache/poi/poifs/filesystem/DirectoryNode.html"
                                        title="class in org.apache.poi.poifs.filesystem">DirectoryNode</a>&nbsp;node,
                                    java.util.Map&lt;java.lang.String,java.lang.String&gt;&nbsp;moduleNameMap,
                                    <a href="../../../../../org/apache/poi/poifs/macros/VBAMacroReader.ModuleMap.html"
                                       title="class in org.apache.poi.poifs.macros">VBAMacroReader.ModuleMap</a>&nbsp;modules)</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i3" class="rowColor">
                                <td class="colFirst"><code>protected void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/macros/VBAMacroReader.html#findProjectProperties-org.apache.poi.poifs.filesystem.DirectoryNode-java.util.Map-org.apache.poi.poifs.macros.VBAMacroReader.ModuleMap-">findProjectProperties</a></span>(<a
                                        href="../../../../../org/apache/poi/poifs/filesystem/DirectoryNode.html"
                                        title="class in org.apache.poi.poifs.filesystem">DirectoryNode</a>&nbsp;node,
                                    java.util.Map&lt;java.lang.String,java.lang.String&gt;&nbsp;moduleNameMap,
                                    <a href="../../../../../org/apache/poi/poifs/macros/VBAMacroReader.ModuleMap.html"
                                       title="class in org.apache.poi.poifs.macros">VBAMacroReader.ModuleMap</a>&nbsp;modules)</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i4" class="altColor">
                                <td class="colFirst"><code>java.util.Map&lt;java.lang.String,<a
                                        href="../../../../../org/apache/poi/poifs/macros/Module.html"
                                        title="interface in org.apache.poi.poifs.macros">Module</a>&gt;</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/macros/VBAMacroReader.html#readMacroModules--">readMacroModules</a></span>()</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i5" class="rowColor">
                                <td class="colFirst"><code>java.util.Map&lt;java.lang.String,java.lang.String&gt;</code>
                                </td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/macros/VBAMacroReader.html#readMacros--">readMacros</a></span>()</code>
                                    <div class="block">Reads all macros from all modules of the opened office file.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i6" class="altColor">
                                <td class="colFirst"><code>protected void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/macros/VBAMacroReader.html#readMacros-org.apache.poi.poifs.filesystem.DirectoryNode-org.apache.poi.poifs.macros.VBAMacroReader.ModuleMap-">readMacros</a></span>(<a
                                        href="../../../../../org/apache/poi/poifs/filesystem/DirectoryNode.html"
                                        title="class in org.apache.poi.poifs.filesystem">DirectoryNode</a>&nbsp;macroDir,
                                    <a href="../../../../../org/apache/poi/poifs/macros/VBAMacroReader.ModuleMap.html"
                                       title="class in org.apache.poi.poifs.macros">VBAMacroReader.ModuleMap</a>&nbsp;modules)</code>
                                    <div class="block">Reads VBA Project modules from a VBA Project directory located at
                                        <tt>macroDir</tt> into <tt>modules</tt>.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i7" class="rowColor">
                                <td class="colFirst"><code>protected void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/macros/VBAMacroReader.html#readNameMapRecords-java.io.InputStream-java.util.Map-java.nio.charset.Charset-">readNameMapRecords</a></span>(java.io.InputStream&nbsp;is,
                                    java.util.Map&lt;java.lang.String,java.lang.String&gt;&nbsp;moduleNames,
                                    java.nio.charset.Charset&nbsp;charset)</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i8" class="altColor">
                                <td class="colFirst"><code>protected void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/macros/VBAMacroReader.html#readProjectProperties-org.apache.poi.poifs.filesystem.DocumentInputStream-java.util.Map-org.apache.poi.poifs.macros.VBAMacroReader.ModuleMap-">readProjectProperties</a></span>(<a
                                        href="../../../../../org/apache/poi/poifs/filesystem/DocumentInputStream.html"
                                        title="class in org.apache.poi.poifs.filesystem">DocumentInputStream</a>&nbsp;dis,
                                    java.util.Map&lt;java.lang.String,java.lang.String&gt;&nbsp;moduleNameMap,
                                    <a href="../../../../../org/apache/poi/poifs/macros/VBAMacroReader.ModuleMap.html"
                                       title="class in org.apache.poi.poifs.macros">VBAMacroReader.ModuleMap</a>&nbsp;modules)</code>&nbsp;
                                </td>
                            </tr>
                        </table>
                        <ul class="blockList">
                            <li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
                                <!--   -->
                            </a>
                                <h3>Methods inherited from class&nbsp;java.lang.Object</h3>
                                <code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait,
                                    wait, wait</code></li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
    <div class="details">
        <ul class="blockList">
            <li class="blockList">
                <!-- ============ FIELD DETAIL =========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="field.detail">
                        <!--   -->
                    </a>
                        <h3>Field Detail</h3>
                        <a name="VBA_PROJECT_OOXML">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>VBA_PROJECT_OOXML</h4>
                                <pre>protected static final&nbsp;java.lang.String VBA_PROJECT_OOXML</pre>
                                <dl>
                                    <dt><span class="seeLabel">See Also:</span></dt>
                                    <dd>
                                        <a href="../../../../../constant-values.html#org.apache.poi.poifs.macros.VBAMacroReader.VBA_PROJECT_OOXML">Constant
                                            Field Values</a></dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="VBA_PROJECT_POIFS">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>VBA_PROJECT_POIFS</h4>
                                <pre>protected static final&nbsp;java.lang.String VBA_PROJECT_POIFS</pre>
                                <dl>
                                    <dt><span class="seeLabel">See Also:</span></dt>
                                    <dd>
                                        <a href="../../../../../constant-values.html#org.apache.poi.poifs.macros.VBAMacroReader.VBA_PROJECT_POIFS">Constant
                                            Field Values</a></dd>
                                </dl>
                            </li>
                        </ul>
                    </li>
                </ul>
                <!-- ========= CONSTRUCTOR DETAIL ======== -->
                <ul class="blockList">
                    <li class="blockList"><a name="constructor.detail">
                        <!--   -->
                    </a>
                        <h3>Constructor Detail</h3>
                        <a name="VBAMacroReader-java.io.InputStream-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>VBAMacroReader</h4>
                                <pre>public&nbsp;VBAMacroReader(java.io.InputStream&nbsp;rstream)
               throws java.io.IOException</pre>
                                <dl>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code></dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="VBAMacroReader-java.io.File-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>VBAMacroReader</h4>
                                <pre>public&nbsp;VBAMacroReader(java.io.File&nbsp;file)
               throws java.io.IOException</pre>
                                <dl>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code></dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="VBAMacroReader-org.apache.poi.poifs.filesystem.POIFSFileSystem-">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>VBAMacroReader</h4>
                                <pre>public&nbsp;VBAMacroReader(<a
                                        href="../../../../../org/apache/poi/poifs/filesystem/POIFSFileSystem.html"
                                        title="class in org.apache.poi.poifs.filesystem">POIFSFileSystem</a>&nbsp;fs)</pre>
                            </li>
                        </ul>
                    </li>
                </ul>
                <!-- ============ METHOD DETAIL ========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.detail">
                        <!--   -->
                    </a>
                        <h3>Method Detail</h3>
                        <a name="close--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>close</h4>
                                <pre>public&nbsp;void&nbsp;close()
           throws java.io.IOException</pre>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code>close</code>&nbsp;in interface&nbsp;<code>java.io.Closeable</code></dd>
                                    <dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
                                    <dd><code>close</code>&nbsp;in interface&nbsp;<code>java.lang.AutoCloseable</code>
                                    </dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code></dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="readMacroModules--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>readMacroModules</h4>
                                <pre>public&nbsp;java.util.Map&lt;java.lang.String,<a
                                        href="../../../../../org/apache/poi/poifs/macros/Module.html"
                                        title="interface in org.apache.poi.poifs.macros">Module</a>&gt;&nbsp;readMacroModules()
                                                        throws java.io.IOException</pre>
                                <dl>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code></dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="readMacros--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>readMacros</h4>
                                <pre>public&nbsp;java.util.Map&lt;java.lang.String,java.lang.String&gt;&nbsp;readMacros()
                                                            throws java.io.IOException</pre>
                                <div class="block">Reads all macros from all modules of the opened office file.</div>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>All the macros and their contents</dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code></dd>
                                    <dt><span class="simpleTagLabel">Since:</span></dt>
                                    <dd>3.15-beta2</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="findMacros-org.apache.poi.poifs.filesystem.DirectoryNode-org.apache.poi.poifs.macros.VBAMacroReader.ModuleMap-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>findMacros</h4>
                                <pre>protected&nbsp;void&nbsp;findMacros(<a
                                        href="../../../../../org/apache/poi/poifs/filesystem/DirectoryNode.html"
                                        title="class in org.apache.poi.poifs.filesystem">DirectoryNode</a>&nbsp;dir,
                          <a href="../../../../../org/apache/poi/poifs/macros/VBAMacroReader.ModuleMap.html"
                             title="class in org.apache.poi.poifs.macros">VBAMacroReader.ModuleMap</a>&nbsp;modules)
                   throws java.io.IOException</pre>
                                <div class="block">Recursively traverses directory structure rooted at <tt>dir</tt>.
                                    For each macro module that is found, the module's name and code are
                                    added to <tt>modules<tt>.</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>dir</code> - The directory of entries to look at</dd>
                                    <dd><code>modules</code> - The resulting map of modules</dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code> - If reading the VBA module fails</dd>
                                    <dt><span class="simpleTagLabel">Since:</span></dt>
                                    <dd>3.15-beta2</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="readMacros-org.apache.poi.poifs.filesystem.DirectoryNode-org.apache.poi.poifs.macros.VBAMacroReader.ModuleMap-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>readMacros</h4>
                                <pre>protected&nbsp;void&nbsp;readMacros(<a
                                        href="../../../../../org/apache/poi/poifs/filesystem/DirectoryNode.html"
                                        title="class in org.apache.poi.poifs.filesystem">DirectoryNode</a>&nbsp;macroDir,
                          <a href="../../../../../org/apache/poi/poifs/macros/VBAMacroReader.ModuleMap.html"
                             title="class in org.apache.poi.poifs.macros">VBAMacroReader.ModuleMap</a>&nbsp;modules)
                   throws java.io.IOException</pre>
                                <div class="block">Reads VBA Project modules from a VBA Project directory located at
                                    <tt>macroDir</tt> into <tt>modules</tt>.
                                </div>
                                <dl>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code></dd>
                                    <dt><span class="simpleTagLabel">Since:</span></dt>
                                    <dd>3.15-beta2</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="findProjectProperties-org.apache.poi.poifs.filesystem.DirectoryNode-java.util.Map-org.apache.poi.poifs.macros.VBAMacroReader.ModuleMap-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>findProjectProperties</h4>
                                <pre>protected&nbsp;void&nbsp;findProjectProperties(<a
                                        href="../../../../../org/apache/poi/poifs/filesystem/DirectoryNode.html"
                                        title="class in org.apache.poi.poifs.filesystem">DirectoryNode</a>&nbsp;node,
                                     java.util.Map&lt;java.lang.String,java.lang.String&gt;&nbsp;moduleNameMap,
                                     <a href="../../../../../org/apache/poi/poifs/macros/VBAMacroReader.ModuleMap.html"
                                        title="class in org.apache.poi.poifs.macros">VBAMacroReader.ModuleMap</a>&nbsp;modules)
                              throws java.io.IOException</pre>
                                <dl>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code></dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="findModuleNameMap-org.apache.poi.poifs.filesystem.DirectoryNode-java.util.Map-org.apache.poi.poifs.macros.VBAMacroReader.ModuleMap-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>findModuleNameMap</h4>
                                <pre>protected&nbsp;void&nbsp;findModuleNameMap(<a
                                        href="../../../../../org/apache/poi/poifs/filesystem/DirectoryNode.html"
                                        title="class in org.apache.poi.poifs.filesystem">DirectoryNode</a>&nbsp;node,
                                 java.util.Map&lt;java.lang.String,java.lang.String&gt;&nbsp;moduleNameMap,
                                 <a href="../../../../../org/apache/poi/poifs/macros/VBAMacroReader.ModuleMap.html"
                                    title="class in org.apache.poi.poifs.macros">VBAMacroReader.ModuleMap</a>&nbsp;modules)
                          throws java.io.IOException</pre>
                                <dl>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code></dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="readNameMapRecords-java.io.InputStream-java.util.Map-java.nio.charset.Charset-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>readNameMapRecords</h4>
                                <pre>protected&nbsp;void&nbsp;readNameMapRecords(java.io.InputStream&nbsp;is,
                                  java.util.Map&lt;java.lang.String,java.lang.String&gt;&nbsp;moduleNames,
                                  java.nio.charset.Charset&nbsp;charset)
                           throws java.io.IOException</pre>
                                <dl>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code></dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="readProjectProperties-org.apache.poi.poifs.filesystem.DocumentInputStream-java.util.Map-org.apache.poi.poifs.macros.VBAMacroReader.ModuleMap-">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>readProjectProperties</h4>
                                <pre>protected&nbsp;void&nbsp;readProjectProperties(<a
                                        href="../../../../../org/apache/poi/poifs/filesystem/DocumentInputStream.html"
                                        title="class in org.apache.poi.poifs.filesystem">DocumentInputStream</a>&nbsp;dis,
                                     java.util.Map&lt;java.lang.String,java.lang.String&gt;&nbsp;moduleNameMap,
                                     <a href="../../../../../org/apache/poi/poifs/macros/VBAMacroReader.ModuleMap.html"
                                        title="class in org.apache.poi.poifs.macros">VBAMacroReader.ModuleMap</a>&nbsp;modules)
                              throws java.io.IOException</pre>
                                <dl>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code></dd>
                                </dl>
                            </li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.bottom.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/VBAMacroReader.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../../../index-all.html">Index</a></li>
        <li><a href="../../../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li><a href="../../../../../org/apache/poi/poifs/macros/VBAMacroExtractor.html"
               title="class in org.apache.poi.poifs.macros"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
        <li><a href="../../../../../org/apache/poi/poifs/macros/VBAMacroReader.ModuleImpl.html"
               title="class in org.apache.poi.poifs.macros"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
    </ul>
    <ul class="navList">
        <li><a href="../../../../../index.html?org/apache/poi/poifs/macros/VBAMacroReader.html" target="_top">Frames</a>
        </li>
        <li><a href="VBAMacroReader.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_bottom">
        <li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li><a href="#nested.class.summary">Nested</a>&nbsp;|&nbsp;</li>
            <li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
            <li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
            <li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.bottom">
        <!--   -->
    </a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy">
    <small>
        <i>Copyright 2018 The Apache Software Foundation or
            its licensors, as applicable.</i>
    </small>
</p>
</body>
</html>
